#ifndef OPENGL_SHADER_H
#define OPENGL_SHADER_H

#include <string>
#include <epoxy/gl.h>

class OpenGlShaderProgram
{
	public:
		OpenGlShaderProgram(std::string vertex_file, std::string geometry_file, std::string fragment_file);
		~OpenGlShaderProgram();
		int compile();
		void unload();
		int use();
		int getUniformLoc(const std::string &uniform);
		void setUniformFloat(const std::string &uniform, float value);
		void setUniformVec2(const std::string &uniform, float *vector);
	private:
		bool compiled;
		GLuint shader_program;
		std::string vertex_file;
		std::string geometry_file;
		std::string fragment_file;
};

#endif // OPENGL_SHADER_H
